/*****************************************************************************
@doc            INT EXT
******************************************************************************
* $ProjectName:  $
* $ProjectRevision:  $
*-----------------------------------------------------------------------------
* $Source: z:/pr/cmcommon/sw/pcsc_cm/rcs/ccid_ok.h $
* $Revision: 1 $
*-----------------------------------------------------------------------------
* $Author: Thorsten $
*-----------------------------------------------------------------------------
* History: see EOF
*-----------------------------------------------------------------------------
*
******************************************************************************/

#ifndef _INC_SPE_STANDARD_
#define _INC_SPE_STANDARD_

/*****************************************************************************/
/** includes                                                                **/
/*****************************************************************************/

#ifndef _WIN32
 #include <PCSC/reader.h>
#else
 #include <winsmcrd.h>

 #define CM_IOCTL_GET_FEATURE_REQUEST         SCARD_CTL_CODE (3400)

#define FEATURE_VERIFY_PIN_START	0x01
#define FEATURE_VERIFY_PIN_FINISH	0x02
#define FEATURE_MODIFY_PIN_START	0x03
#define FEATURE_MODIFY_PIN_FINISH 	0x04
#define FEATURE_GET_KEY_PRESSED	    0x05
#define FEATURE_VERIFY_PIN_DIRECT	0x06
#define FEATURE_MODIFY_PIN_DIRECT	0x07
#define FEATURE_MKT_READER_DIRECT	0x08
#define FEATURE_MKT_UNIVERSAL	    0x09

#endif

// All structures and unions are aligned with 1. Save the initila pack value in old_..
#pragma pack(push,old_value,1)




   #define CCID_SPE_VERIFY_PIN     0x00
   #define CCID_SPE_MODIFY_PIN     0x01
   #define CCID_SPE_CANCEL_PIN     0x04


   #define CCID_FORMAT_SYSTEM_UNITS_BIT       0x00
   #define CCID_FORMAT_SYSTEM_UNITS_BYTE      0x80

   #define CCID_FORMAT_JUSTIFICATION_LEFT     0x00
   #define CCID_FORMAT_JUSTIFICATION_RIGHT    0x04

   #define CCID_FORMAT_PIN_BINARY             0x00
   #define CCID_FORMAT_PIN_BCD                0x01
   #define CCID_FORMAT_PIN_ASCII              0x02


   #define CCID_COND_MAX_SIZE_REACHED            0x01
   #define CCID_COND_VALIDATION_KEY_PRESSED      0x02
   #define CCID_COND_TIMEOUT_OCCURED             0x04



   /*****************************************************************************/
   /**  SPE structures                                                         **/
   /*****************************************************************************/

   typedef struct _USB_CCID_PIN_VERIFY_STRUCTURE
      {
      UCHAR  bTimeOut;
      UCHAR  bTimeOut2;
      UCHAR  bmFormatString;
      UCHAR  bmPINBlockString;
      UCHAR  bmPINLengthFormat;
      USHORT wPINMaxExtraDigit;
      UCHAR  bEntryValidationCondition;
      UCHAR  bNumberMessage;
      USHORT wLangId;
      UCHAR  bMsgIndex;
      UCHAR  bTeoPrologue[3];
      ULONG  ulDataLength;
      UCHAR  abData[1];
      } USB_CCID_PIN_VERIFY_STRUCTURE, *PUSB_CCID_PIN_VERIFY_STRUCTURE;


   typedef struct _USB_CCID_PIN_MODIFY_STRUCTURE
      {
      UCHAR  bTimeOut;
      UCHAR  bTimeOut2;
      UCHAR  bmFormatString;
      UCHAR  bmPINBlockString;
      UCHAR  bmPINLengthFormat;
      UCHAR  bInsertionOffsetOld;
      UCHAR  bInsertionOffsetNew;
      USHORT wPINMaxExtraDigit;
      UCHAR  bConfirmPIN;
      UCHAR  bEntryValidationCondition;
      UCHAR  bNumberMessage;
      USHORT wLangId;
      UCHAR  bMsgIndex1;
      UCHAR  bMsgIndex2;
      UCHAR  bMsgIndex3;
      UCHAR  bTeoPrologue[3];
      ULONG  ulDataLength;
      UCHAR  abData[1];
      }USB_CCID_PIN_MODIFY_STRUCTURE , *PUSB_CCID_PIN_MODIFY_STRUCTURE;



#pragma pack(pop,old_value)
// Restore the old packing value.

#endif   /*_INC_SPE_STANDARD_ */

/*****************************************************************************
* History:
* $Log: /Cardmodule/Pkcs#11/spe_standard.h $
 * 
 * 1     7.05.07 16:28 Thorsten
*****************************************************************************/

