//---------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <conio.h>

//Includes fr PKCS#11
#include "cryptoki.h"
#include "p11Functions.h"

int main(int argc, char* argv[])
{
   CK_FUNCTION_LIST_PTR p11;
   CK_SLOT_ID SlotID;
   CK_SESSION_HANDLE hSession;
   CK_OBJECT_HANDLE pCertificateHandle, pKeyHandle;

   if ((argc != 2)) {
		printf("\nUsage: pkcs11_sign.exe LibraryName");
		exit(0);
   }
   p11 = LoadP11(argv[1]);
   if (p11 == NULL) {
		printf("\nFehler beim Laden der Library (%s) !", argv[1]);
		exit(0);
   }  else {
		printf("\n ... LoadP11() erflogreich (%s)", argv[1]);
   }
   SlotID = selectSlot(p11);
   if (SlotID == 0) {
		printf("\nFehler beim ermitteln der SlotID !");
		exit(0);
   }  else {
		printf("\n ... selectSlot() erflogreich: %d", SlotID);
   }
   hSession = startLogInSession(p11, SlotID);
   if (hSession == 0) {
		printf("\nFehler beim Login !");
		exit(0);
   }  else {
		printf("\n ... startLogInSession() erflogreich: %X\n", hSession);
   }
   pCertificateHandle = selectCertificate(p11, hSession);
   if (pCertificateHandle == 0) {
		printf("\nFehler bei selectCertificate() !");
		exit(0);
   }  else {
		printf("\n ... selectCertificate() erflogreich: 0x%X\n", pCertificateHandle);
   }
   pKeyHandle = selectPrivateKeyByCertificate(p11, hSession, pCertificateHandle);
   if (pKeyHandle == 0) {
		printf("\nFehler bei selectKeyByCertificate() !");
		exit(0);
   }  else {
		printf("\n ... selectKeyByCertificate() erflogreich: 0x%X\n", pKeyHandle);
   }
   unsigned char pData[512];
   for(int i=0; i<512; i++) pData[i] = i % 256;
   DWORD dLenSignature = sizeof(pData);
   printf("\n ... Daten (Laenge: %d):", dLenSignature);
   printSignature(pData,dLenSignature);
   printf("\n");
   if (signData(p11, hSession, pKeyHandle, pData, &dLenSignature) != CKR_OK) {
		printf("\nFehler bei signData() !");
		exit(0);
   }  else {
		printf("\n ... Signatur (Laenge: %d):", dLenSignature);
		printSignature(pData,dLenSignature);
		printf("\n");
   }
   cleanUp(p11, hSession);
   printf("\nTest erfolgreich !");
   getch();

}
//---------------------------------------------------------------------------
